function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}

var omitMultiple = function omitMultiple(o, keys) {
  var exclude = new Set(keys);
  return Object.fromEntries(Object.entries(o).filter(function (e) {
    return !exclude.has(e[0]);
  }));
};
var getFieldsObj = function getFieldsObj(fields) {
  return fields.reduce(function (acc, curr) {
    var _extends2;
    var currKey;
    var currValue;
    if (typeof curr === 'object') {
      currKey = curr.key;
      currValue = curr.value;
    } else if (typeof curr === 'string') {
      currKey = curr;
      currValue = null;
    }
    return _extends({}, acc, (_extends2 = {}, _extends2[currKey] = currValue, _extends2));
  }, {});
};

var REDUX_FIELD_NAME = 'fields';
var SIMPLE_REDUX_FIELDS__OPEN = 'SIMPLE_REDUX_FIELDS__OPEN';
var SIMPLE_REDUX_FIELDS__CLOSE = 'SIMPLE_REDUX_FIELDS__CLOSE';
var SIMPLE_REDUX_FIELDS__SET = 'SIMPLE_REDUX_FIELDS__SET';

var _simpleReduxFieldRedu;
var initialState = {};
var reducer = function reducer(state, action) {
  if (state === void 0) {
    state = initialState;
  }
  var payload = action.payload;
  switch (action.type) {
    case SIMPLE_REDUX_FIELDS__OPEN:
      return fieldsSet(state, payload);
    case SIMPLE_REDUX_FIELDS__CLOSE:
      return fieldsClose(state, payload);
    case SIMPLE_REDUX_FIELDS__SET:
      return fieldsSet(state, payload);
    default:
      return state;
  }
};
var simpleReduxFieldReducer = (_simpleReduxFieldRedu = {}, _simpleReduxFieldRedu[REDUX_FIELD_NAME] = reducer, _simpleReduxFieldRedu);
var fieldsSet = function fieldsSet(state, payload) {
  return Object.keys(payload).reduce(function (acc, curr) {
    var value = payload[curr];
    if (typeof value === 'object' && value !== null) {
      var _extends2;
      return _extends({}, acc, (_extends2 = {}, _extends2[curr] = _extends({}, state[curr], value), _extends2));
    } else {
      var _extends3;
      return _extends({}, acc, (_extends3 = {}, _extends3[curr] = value, _extends3));
    }
  }, state);
};
var fieldsClose = function fieldsClose(state, payload) {
  return omitMultiple(state, payload);
};

var fieldsOpen = function fieldsOpen(fieldsObj) {
  return {
    type: SIMPLE_REDUX_FIELDS__OPEN,
    payload: fieldsObj
  };
};
var fieldsClose$1 = function fieldsClose(keys) {
  return {
    type: SIMPLE_REDUX_FIELDS__CLOSE,
    payload: keys
  };
};
var fieldsSet$1 = function fieldsSet(fieldsObj) {
  return {
    type: SIMPLE_REDUX_FIELDS__SET,
    payload: fieldsObj
  };
};

var fieldsOpen$1 = function fieldsOpen$1(fields) {
  return function (dispatch) {
    dispatch(fieldsOpen(getFieldsObj(fields)));
  };
};
var fieldsClose$2 = function fieldsClose(keys) {
  return function (dispatch) {
    dispatch(fieldsClose$1(keys));
  };
};
var fieldsSet$2 = function fieldsSet(fields) {
  return function (dispatch) {
    dispatch(fieldsSet$1(getFieldsObj(fields)));
  };
};
var fieldSet = function fieldSet(key, value) {
  return function (dispatch) {
    dispatch(fieldsSet$2([{
      key: key,
      value: value
    }]));
  };
};

var $fields = function $fields(state) {
  return state[REDUX_FIELD_NAME];
};

exports.$fields = $fields;
exports.fieldSet = fieldSet;
exports.fieldsClose = fieldsClose$2;
exports.fieldsOpen = fieldsOpen$1;
exports.fieldsSet = fieldsSet$2;
exports.simpleReduxFieldReducer = simpleReduxFieldReducer;
//# sourceMappingURL=index.js.map
